/*    Soft Fractals indicator -      
       . */
#property copyright "Copyright 2012, 2015,  .."
#property link      "alextar@bk.ru"
#property strict
#property indicator_chart_window                   //    
//  
#property indicator_buffers 2
#property indicator_color1 Green                   //  
#property indicator_width1 3
#property indicator_color2 Red                     //  
#property indicator_width2 3
double Bottom[], Top[];                            // 
// 
#define Zero         0.00000001                    //   
#define BottomSymbol 218                           //    
#define TopSymbol    217
//  
extern int  LeftWing      =2,
            RightWing     =2;
input  bool StrictFractals=false;
//+------------------------------------------------------------------+
int OnInit(){
   ArraySetAsSeries(Bottom,true);                  //  
   SetIndexLabel(0,"Bottom");
   SetIndexBuffer(0,Bottom);
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,BottomSymbol);
   SetIndexEmptyValue(0,0);
   ArraySetAsSeries(Top,true);
   SetIndexLabel(1,"Top");
   SetIndexBuffer(1,Top);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,TopSymbol);
   SetIndexEmptyValue(1,0);
   if( LeftWing  <0 ) LeftWing =-LeftWing;         //  
   if( RightWing <0 ) RightWing=-RightWing;
   return(0);
}
//+------------------------------------------------------------------+
int start(){
   int i, History=Bars-1, BarsLost=History-IndicatorCounted();
   if( BarsLost<History ){
      if( BarsLost<1 ) return(0);                  //    - 
      i=BarsLost+RightWing;                        //   
   }
   else i=History-LeftWing;                        //    
   double C[];
   int dim=ArrayResize(C,LeftWing+1+RightWing), j;
   while( i > RightWing ){                         //   
      j=0;                                         //   
      Bottom[i]=0;
      while( j < dim ){                            //   
         C[j]=Low[j+i-RightWing];
         j++;
      }
      if( ( LeftWing                    < 1        //   , 
         || C[RightWing+1]-C[RightWing] > -Zero )  //       
       && ( RightWing                   < 1        //   , 
         || C[RightWing-1]-C[RightWing] > -Zero ) ){  //    
         Bottom[i]=C[RightWing];                   //    
         j=1;
         while ( j < dim-1 ){
            if( ( j < RightWing                    //   ;    :
                 && ( ( !StrictFractals && Bottom[i]-C[j-1] > Zero )          // ( )
                   || (  StrictFractals && C[j]-C[j-1]      > Zero ) ) )      // ( )
             || ( j > RightWing                    //   ;    :
                 && ( ( !StrictFractals && Bottom[i]-C[j+1] > Zero )          // ( )
                   || (  StrictFractals && C[j]-C[j+1]      > Zero ) ) ) ) {  // ( )
               Bottom[i]=0;                        //    
               break;
            }
            j++;
         }
      }
      j=0;                                         //   
      Top[i]=0;
      while( j<dim ){                              //   
         C[j]=High[j+i-RightWing];
         j++;
      }
      if( ( LeftWing                    < 1        //   , 
         || C[RightWing]-C[RightWing+1] > -Zero )  //       
       && ( RightWing                   < 1        //   , 
         || C[RightWing]-C[RightWing-1] > -Zero ) ){  //    
         Top[i]=C[RightWing];                      //    
         j=1;
         while( j < dim-1 ){
            if( ( j < RightWing                    //   ;    :
                 && ( ( !StrictFractals && C[j-1]-Top[i] > Zero )          // ( )
                   || (  StrictFractals && C[j-1]-C[j]   > Zero ) ) )      // ( )
             || ( j > RightWing                    //   ;    :
                 && ( ( !StrictFractals && C[j+1]-Top[i] > Zero )          // ( )
                   || (  StrictFractals && C[j+1]-C[j]   > Zero ) ) ) ) {  // ( )
               Top[i]=0;                           //    
               break;
            }
            j++;
         }
      }
      i--;
   }
   return(0);
}